various fixes
[automated-distro-installer] / myfai-chboot-local
index 3ecc7d13f83d5b3beb8af69327faca4c875f56ad..c631d5699d073e6e27d9ccae8d8454cce7c2b8e5 100755 (executable)
@@ -7,6 +7,7 @@ set -eE -o pipefail
 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
 
 kgped16=false
+bond=false
 fai_action=install
 fai_reboot_arg=,reboot
 while [[ $1 == -* ]]; do
@@ -26,34 +27,56 @@ while [[ $1 == -* ]]; do
       shift
       ;;
     -k)
-      kgped16=true;
+      kgped16=true
+      shift
+      ;;
+    -b)
+      bond=true
+      shift
+      ;;
+    --no-r)
+      fai_reboot_arg=
       shift
       ;;
   esac
 done
 
-e() {
-  echo "$*"
-  if ! "$@"; then
-    echo "$0: error: exit code $? from: $*"
-    exit 1
-  fi
-}
+pre="${0##*/}:"
+m() { printf "$pre %s\n"  "$*"; "$@"; }
+e() { printf "$pre %s\n"  "$*"; }
+err() { echo "[$(date +'%Y-%m-%d %H:%M:%S%z')]: $pre: $*" >&2; }
 
 host=$1
 
+
 rm -f /srv/tftp/fai/pxelinux.cfg/*
 if [[ ! $1 ]]; then
   echo "$0: clearing pxe config and exiting"
   exit 0
 fi
 
-# assuming ipv4, or else we might need to deal with multiple addresses
-# in an ipv4 + ipv6 network.
-my_ip=$(ip -4 route get 8.8.8.8 | sed -nr 's,^.*src\s+(\S+).*,\1,p')
-if [[ ! $my_ip || $my_ip =~ [[:space:]] ]]; then
-  echo "$0: error: failed to get \$my_ip, got: $my_ip"
-  exit 1
+# somewhat duplicated in brc hostip()
+case $host in
+  default) : ;;
+  [0-9:])
+    hostip=$host
+    ;;
+  *)
+    hostip=$(getent ahostsv4 "$host" | awk '{ print $1 }' | head -n1)
+    ;;
+esac
+
+if [[ $hostip ]]; then
+
+  # assuming ipv4, or else we might need to deal with multiple addresses
+  # in an ipv4 + ipv6 network.
+  my_ip=$(ip -4 route get $hostip | sed -nr 's,^.*src\s+(\S+).*,\1,p')
+  if [[ ! $my_ip || $my_ip =~ [[:space:]] ]]; then
+    echo "$0: error: failed to get \$my_ip, got: $my_ip"
+    exit 1
+  fi
+else
+  my_ip=$(ip r show default | sed -r 's/.*via ([^ ]*).*/\1/' | head -n1)
 fi
 
 if [[ $host == default ]]; then
@@ -68,6 +91,7 @@ else
     exit 1
   fi
   ip=$ip/32
+  echo "$0: found ip of $host: $ip"
 fi
 
 if modprobe nfsd &>/dev/null; then
@@ -105,14 +129,19 @@ fi
 
 # man page doesn't explain this, but this deletes & thus disables
 # all chboot systems.
-e fai-chboot -iv $std_arg default # set it to default to get a val out of it next
+m fai-chboot -iv $std_arg default # set it to default to get a val out of it next
 kernel=$(fai-chboot -L '^default$' | awk '{print $3}')
 default_k_args=$(fai-chboot -L '^default$' | \
                    sed -r "s/^(\S+\s+){3}(.*)/\2/")
 # example of default_k_args
-# initrd=initrd.img-3.16.0-4-amd64 ip=dhcp root=192.168.1.3:/srv/fai/nfsroot aufs FAI_CONFIG_SRC=nfs://faiserver/srv/fai/config FAI_ACTION=install
-
-k_args=(FAI_ACTION=$fai_action)
+# initrd=initrd.img-3.16.0-4-amd64 ip=dhcp root=192.168.1.3:/srv/fai/nfsroot FAI_CONFIG_SRC=nfs://faiserver/srv/fai/config FAI_ACTION=install
+
+# https://wiki.archlinux.org/index.php/Solid_state_drive#Resolving_NCQ_errors
+# currently on needed on d16 samsung 870 qvo, but better to have this
+# and not wait for more conditions where its needed.
+#k_args=(FAI_ACTION=$fai_action libata.force=noncq ifname:bootnet0:08:60:6e:10:f0:fe ifname:bootnet1:08:60:6e:10:f0:98 bond=bond0:bootnet0,bootnet1:mode=balance-rr)
+#k_args=(FAI_ACTION=$fai_action libata.force=noncq ifname:bootnet0:08:60:6e:10:f0:fe biosdevname=0 bootdev=bootnet0)
+k_args=(FAI_ACTION=$fai_action libata.force=noncq)
 if $kgped16; then
   k_args+=(console=tty0 console=ttyS0,115200)
 fi
@@ -121,11 +150,19 @@ for arg in $default_k_args; do
   case $arg in
     # default root arg is /srv/fai/nfsroot
     root=*) k_args+=(root=$root_arg) ;;
+    # note: this works to only dhcp on one interface: ip=eth0:dhcp
+    ip=*)
+      if $bond; then
+        k_args+=("bond=bond0:eth0,eth1:mode=balance-rr ip=bond0:dhcp")
+      else
+        k_args+=($arg)
+      fi
+      ;;
     *) k_args+=($arg) ;;
   esac
 done
 rm -f /srv/tftp/fai/pxelinux.cfg/*
-e fai-chboot -k "${k_args[*]}" -v -f verbose,sshd,createvt$fai_reboot_arg $std_arg $kernel "$host"
+m fai-chboot -k "${k_args[*]}" -v -f verbose,sshd,createvt$fai_reboot_arg $std_arg $kernel "$host"
 
 # this is needed for autodiscover iso. i'm not sure, it might override
 # the fai-chboot method of setting this, i'm not sure.